/* Betriebssystem & Middleware
 *
 * Betriebssystemarchitektur WS 2004/05
 *
 * Uebung 4.2 
 */
#include <stdio.h>
#include <windows.h>

static void ErrorHandler(const char * msg)
{

    fprintf(stderr, "Fehler: %s %d\n", msg, GetLastError());
    exit(1);
}


#define BUFSIZE 200


int main (int argc, char *argv[])
{
    HANDLE h;
    char name[BUFSIZE];

    if (argc < 2)
    {
	fprintf(stderr, "Usage: %s <Chat-Room-Name>\n", argv[0]);
	exit(1);
    }

    strcpy (name, "\\\\.\\MAILSLOT\\CHAT\\");

    if ((strlen(name) + strlen(argv[1])) > (BUFSIZE-3))
    {
	fprintf(stderr, "Name too long\n");
	exit(1);
    }

    strcat(name, argv[1]);

    h = CreateMailslot(name, 0, MAILSLOT_WAIT_FOREVER, 0);

    if (h == INVALID_HANDLE_VALUE)
    {
	ErrorHandler("CreateMailslot");
    }


    while(1)
    {
	DWORD count;
	char buf[BUFSIZE];

	if (!ReadFile(h, buf, BUFSIZE-1, &count, 0))
	{
	    ErrorHandler("ReadFile");
	}

	buf[count] = 0;

	printf ("Length:%d Message:%s\n", count, buf);

    }

}
