/* Betriebssystem & Middleware
 *
 * Betriebssystemarchitektur WS 2004/05
 *
 * Uebung 4.2 
 */

#include <stdio.h>
#include <windows.h>

static void ErrorHandler(const char * msg)
{
    fprintf(stderr, "Fehler: %s %d\n", msg, GetLastError());
    exit(1);
}


#define BUFSIZE 200


int main (int argc, char *argv[])
{
    HANDLE h;

    char name[BUFSIZE];

    if (argc < 2)
    {
        fprintf(stderr, "Usage: %s <Chat-Room-Name>\n", argv[0]);
        exit(1);
    }

    strcpy (name, "\\\\*\\MAILSLOT\\CHAT\\");

    if ((strlen(name) + strlen(argv[1])) > (BUFSIZE-3))
    {
        fprintf(stderr, "Name too long\n");
        exit(1);
    }

    strcat(name, argv[1]);



    h = CreateFile(name,
	    GENERIC_WRITE, 
	    FILE_SHARE_READ,
	    (LPSECURITY_ATTRIBUTES) NULL, 
	    OPEN_EXISTING, 
	    FILE_ATTRIBUTE_NORMAL, 
	    (HANDLE) NULL); 


    if (h == INVALID_HANDLE_VALUE)
    {
	ErrorHandler("CreateMailslot");
    }


    printf("Beenden mit /quit\n");

    while(1)
    {
	DWORD w_count;
	char buf[BUFSIZE];

	if (!fgets(buf, BUFSIZE, stdin))
	{
	    if (feof(stdin))
		break;

	    ErrorHandler("fgets");
	}

	if (strncmp(buf, "/q", 2) == 0)
	    break;

	if (!WriteFile(h, buf, strlen(buf), &w_count, 0))
	{
	    ErrorHandler("WriteFile");
	}

    }

    if (!CloseHandle(h))
    {
	ErrorHandler("CloseHandle");
    }

    return 0;
}

